package net.minecraft.src;
import java.util.*;

public class mod_Rope extends BaseModMp
{
	@Override
    public void load()
    {    	
        rtex = ModLoader.addOverride("/terrain.png", "/imgz/rope2.png");
        ModLoader.registerBlock(rope);
        ModLoader.addName(rope, "Rope");
        ModLoader.addRecipe(new ItemStack(rope, 12), new Object[] {
            " # ", " # ", " # ", Character.valueOf('#'), Item.silk
        });
		
		time = System.currentTimeMillis();
		ModLoader.setInGameHook(this, true, false);
    }
	
	@Override
	public boolean onTickInGame(float derp, net.minecraft.client.Minecraft mc)
	{
		if (mc.thePlayer == null || mc.theWorld == null) return false;
		
		if (isOnRope(mc.thePlayer))
		{
			EntityPlayer p = mc.thePlayer;
		
			float threshold = 0.15F;
			p.motionX = p.motionX * 0.59999999999999998D;
			if(p.motionX < (double)(-threshold))
			{
				p.motionX = -threshold;
			}
			if(p.motionX > (double)threshold)
			{
				p.motionX = threshold;
			}
			if(p.motionZ < (double)(-threshold))
			{
				p.motionZ = -threshold;
			}
			if(p.motionZ > (double)threshold)
			{
				p.motionZ = threshold;
			}
			
			p.fallDistance = 0.0F;
			
			if(p.motionY < -0.14999999999999999D)
			{
				p.motionY = -0.14999999999999999D;
			}
			if(p.isSneaking() && p.motionY < 0.0D)
			{
				p.motionY = 0.0D;
			}
			
			if(p.isCollidedHorizontally)
			{
				p.motionY = 0.20000000000000001D;
			}
		}
		
		for(int x = 0; x < ropeEntArray.size(); x++)
		{
			Object temp = ropeEntArray.get(x);
			if (temp instanceof BlockRopePseudoEnt)
			{
				if (((BlockRopePseudoEnt) temp).OnUpdate())
				{
					ropeEntArray.remove(x);
				}
			}
			else if (temp instanceof ASTileEntityRope)
			{
				if (((ASTileEntityRope) temp).OnUpdate())
				{
					ropeEntArray.remove(x);
				}
			}
		}
		
		return true;
	}
	
	public static void onRopeArrowHit(int x, int y, int z)
	{
		int[] coords = new int[3];
		coords[0] = x;
		coords[1] = y;
		coords[2] = z;
		addCoordsToRopeArray(coords);
		
		BlockRopePseudoEnt newent = new BlockRopePseudoEnt(ModLoader.getMinecraftInstance().theWorld, x, y, z, 31);
		addRopeToArray(newent);
	}
	
	public static void addRopeToArray(BlockRopePseudoEnt ent)
	{
		ropeEntArray.add(ent);
	}
	
	public static void addRopeToArray(ASTileEntityRope newent)
	{
		ropeEntArray.add(newent);
	}
	
	public static void addCoordsToRopeArray(int[] coords)
	{
		ropePosArray.add(coords);
	}
	
	public static void removeCoordsFromRopeArray(int[] coords)
	{
		ropePosArray.remove(coords);
	}
	
	public static int[] areCoordsArrowRope(int i, int j, int k)
	{
		for(int w = 0; w < ropePosArray.size(); w++)
		{
			int[] coords = (int[])ropePosArray.get(w);
			
			if (i == coords[0] && j == coords[1] && k == coords[2])
			{
				return coords;
			}
		}
		return null;
	}
	
	static java.util.List ropeEntArray = new ArrayList();
	static java.util.List ropePosArray = new ArrayList();
	
    public boolean isOnRope(EntityPlayer entPlayer)
    {
		if (overrideDisableRopes) return false;
	
        int i = MathHelper.floor_double(entPlayer.posX);
        int j = MathHelper.floor_double(entPlayer.boundingBox.minY);
        int k = MathHelper.floor_double(entPlayer.posZ);
	
		return entPlayer.worldObj.getBlockId(i, j, k) == rope.blockID || entPlayer.worldObj.getBlockId(i, j, k) == mod_ASGrapplingHook.blockRope.blockID;	
	}
	
	@Override
    public String getVersion()
    {
        return "1.2.3 AS";
    }
	
    public static int idBlock;
    public static Block rope;
    public static int rtex;
	private static long time;
	public static boolean overrideDisableRopes = false;
	
    static
    {
    	AS_Settings_RopePlus.InitSettings();
    	
        idBlock = AS_Settings_RopePlus.blockIdRopeDJRoslin;
        rope = (new BlockRope(idBlock, rtex)).setHardness(0.3F).setStepSound(Block.soundMetalFootstep).setBlockName("rope");
    }
}
