package net.minecraft.src;

import java.util.Random;


public class ASBlockGrapplingHook extends Block
{

    protected ASBlockGrapplingHook(int i, int j, int k)
    {
        super(i, j, Material.wood);
        renderType = k;
        setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 0.125F, 1.0F);
    }

    public AxisAlignedBB getCollisionBoundingBoxFromPool(World world, int i, int j, int k)
    {
        return null;
    }

    public boolean isOpaqueCube()
    {
        return false;
    }

    public boolean renderAsNormalBlock()
    {
        return false;
    }

    public boolean canPlaceBlockAt(World world, int i, int j, int k)
    {
        int l = world.getBlockId(i, j - 1, k);
        if(l == 0 || !Block.blocksList[l].isOpaqueCube())
        {
            return false;
        } else
        {
            return world.getBlockMaterial(i, j - 1, k).isSolid();
        }
    }

    public void onNeighborBlockChange(World world, int i, int j, int k, int l)
    {
        func_314_h(world, i, j, k);
    }

    private boolean func_314_h(World world, int i, int j, int k)
    {
        if(!canPlaceBlockAt(world, i, j, k))
        {
            dropBlockAsItem(world, i, j, k, world.getBlockMetadata(i, j, k), 0);
            world.setBlockWithNotify(i, j, k, 0);
            onBlockDestroyed(world, i, j, k);
            return false;
        } else
        {
            return true;
        }
    }

    public int idDropped(int var1, Random var2, int var3)
    {
        return mod_ASGrapplingHook.itemGrapplingHook.shiftedIndex;
    }

    public int quantityDropped(Random random)
    {
        return 1;
    }
    
    public void onBlockDestroyedByPlayer(World world, int i, int j, int k, int l)
    {
        onBlockDestroyed(world, i, j, k);
    }

    public void onBlockDestroyedByExplosion(World world, int i, int j, int k)
    {
        onBlockDestroyed(world, i, j, k);
    }

    private void onBlockDestroyed(World world, int i, int j, int k)
    {
        int candidates[][] = {
            {
                i - 1, j - 1, k
            }, {
                i + 1, j - 1, k
            }, {
                i, j - 1, k - 1
            }, {
                i, j - 1, k + 1
            }
        };
        for(int l = 0; l < candidates.length; l++)
        {
            if(world.getBlockId(candidates[l][0], candidates[l][1], candidates[l][2]) != mod_ASGrapplingHook.blockRope.blockID)
            {
                continue;
            }
            for(int m = candidates[l][1]; world.getBlockId(candidates[l][0], m, candidates[l][2]) == mod_ASGrapplingHook.blockRope.blockID; m--)
            {
                world.setBlockWithNotify(candidates[l][0], m, candidates[l][2], 0);
            }

        }

    }

    private int renderType;
}
